MageManaBar = {}

MageManaBar_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)
MageManaBar1sec_UpdateInterval = 0.5;

MMBLSM = LibStub("LibSharedMedia-3.0") 

--local MMBmanapoolmultiplier, MMBtempmanapool, MMBmanaoverflow, MMBbloodelfracial, MMBcurrenttime, MMBprevtime, MMBmanaspent, MMBhplost, MMBTimeToOom, MMBTimeToDie, MMBarcaneCD, MMBevocationCD, MMBorbCD, MMBanaGemCD, MMBmanapercent, MMBstep

local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical

function MageManaBar_OnLoad(Frame) 
                                               
    if select(2, UnitClass("player")) ~= "MAGE" then MageManaBarBgFrame:Hide() return end
        
	Frame:RegisterForDrag("LeftButton")
	Frame:RegisterEvent("PLAYER_LOGIN")
	Frame:RegisterEvent("PLAYER_REGEN_DISABLED")
	Frame:RegisterEvent("PLAYER_REGEN_ENABLED")
  	Frame:RegisterEvent("PLAYER_TALENT_UPDATE")
 	Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
 	Frame:RegisterEvent("UNIT_MAXPOWER")
 	Frame:RegisterEvent("UNIT_POWER")
    Frame:RegisterEvent("PLAYER_ENTERING_WORLD")
 	MMBLSM.RegisterCallback(MageManaBar , "LibSharedMedia_Registered", "SharedMedia_Registered") 
	MMBLSM.RegisterCallback(MageManaBar , "LibSharedMedia_Registered", "SharedMedia_Registered") 
    
    if MMBSettings == nil then 
        MMBreset()
    end
 
    MMBevocationCDAnim = 0
    MMBmanaGemCDAnim = 0
    MMBArcaneTorrentCDAnim = 0
    MMBOrbCDAnim = 0
    MMBmanaGemFlash = 0
    MMBevocationFlash = 0
    MMBArcaneTorrentFlash = 0
    MMBOrbFlash = 0
    MMBmanaGemresize = 0
    MMBevocationresize = 0
    MMBArcaneTorrentresize = 0
    MMBOrbresize = 0
    
    MMBLSM:Register("statusbar","CombuBar","Interface\\AddOns\\MageManaBar\\Images\\combubarblack")
    MMBLSM:Register("font","MSBT Bazooka","Interface\\AddOns\\MageManaBar\\Fonts\\Bazooka.ttf")
 
end

-------------------------------
-- helper function for option panel setup
function MMBOptions_OnLoad(panel)
	panel.name = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end


-------------------------------
-- helper function for option panel setup
function MMBInfoOptions_OnLoad(panel)
	panel.name = "Info Panel Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBMarkersOptions_OnLoad(panel)
	panel.name = "Markers Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- helper function for option panel setup
function MMBWarningOptions_OnLoad(panel)
	panel.name = "Warning Panel Settings"
	panel.parent = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end



MMBBaseSettings = {
    {"MageManaBarBgFrame",true,true,1,255,40,{0,0,0,1},true,10,1,true,1,true,true},
    -- mana bar frame : frame,enable,unlock,scale,width,height,color/alpha,background,level,alpha,mana overflow,autohide,markers timers, pins colors
    {"MMBInfoFrame1",true,false,7,83,9,{0.25,0.25,0.3,1},true,2,-11,true,"TTOOM : "},
    -- TTOOM info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text
    {"MMBInfoFrame2",true,false,7,83,9,{0.25,0.25,0.3,1},true,2,-22,true,"TTDIE : "},
    -- TTDIE info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text
    {"MMBInfoFrame3",true,false,7,83,9,{0.25,0.25,0.3,1},true,87,-11,true,""},
    -- ????? info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text
    {"MMBInfoFrame4",true,false,7,83,9,{0.25,0.25,0.3,1},true,87,-22,true,"Mastery : "},
    -- mastery info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text
    {"MMBInfoFrame5",true,false,7,126,9,{0.25,0.25,0.3,1},true,172,-11,true,"Max mana : "},
    -- current mana info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text
    {"MMBInfoFrame6",true,false,7,126,9,{0.25,0.25,0.3,1},true,172,-22,true,"Curr mana : "},
    -- max mana info panel : frame,enable,unlock,Fontsize,width,height,color/alpha,background,xpos,ypos, prefix ,text
    {"MMBevocation",true,true,35},
    -- evocation timer : frame, enable, icon/timer, position
    {"MMBmanaGem",true,true,12405},
    -- mana gem timer : frame, enable, icon/timer, position
    {"MMBmageArmor",true,true,103,false},
    -- mage armor timer : frame, enable, icon/timer, position, frost/fire spec
    {"MMBArcaneTorrent",true,true,94},
    -- arcane torrent timer : frame, enable, icon/timer, position
    {"MMBOrb",true,true,80},
    -- arcane torrent timer : frame, enable, icon/timer, position
    {"MageManaBarInfoFrame",true,true,24,0,0,{0,0,0,1}},
    -- info panel : name, enable, background, height, color/alpha
    {"MMBspellcost",true,0.4},
    -- spellcost : name, enable, alpha
    {"MageManaBarFrame",0,0,0,0,0,{0.2,0.5,0.8,1},"Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar","Fonts\\FRIZQT__.TTF", "Friz Quadrata TT"},
    -- mana bar : name, color/alpha, texture, texture name, font, font name
    {"MageManaBarOverflowFrame",0,0,0,0,0,{1,0.3,0.3,0.5}},
    -- mana bar : name, color/alpha,
    {"MageManaBarWarningBar",true,false,true,230,20,{0.2,0.5,0.86,1},"Interface\\AddOns\\MageManaBar\\Images\\combubarblack", "CombuBar","Interface\\AddOns\\MageManaBar\\Fonts\\Bazooka.ttf", "Bazooka",15},
    -- warning bar : name, enable, unlock, Bg, width, height, color/alpha, texture, texture name, fontsize, font, font name
}

--------------------------------
-- Helper function for Sharemedia support
function MageManaBar:SharedMedia_Registered()
--	print("prut")
    -- do whatever needs to be done to repaint / refont
end
    
-------------------------------
-- CheckButton function for option panel
function MMBcheckButton(button,row,col)

	if (button:GetChecked() == 1) then 
        (MMBSettings[row])[col] = true 
    elseif (button:GetChecked() == nil) then 
        (MMBSettings[row])[col] = false
    end
    
    MMBFrameResize()
end

function MMBcheckButtonOnload(button,row,col)

    if ((MMBSettings[row])[col] == true) then
        button:SetChecked(true)
    elseif ((MMBSettings[row])[col] == false) then
        button:SetChecked(false)
    end
end

MMBprefixtable = {"evocation","manaGem","ArcaneTorrent","mageArmor","Orb"}

-------------------------------
-- Frame resize function
function MMBFrameResize()

	-- Settings for background frame -----------------------------------------
    if ((MMBSettings[1])[2] == true) then
    	MageManaBarBgFrame:Show()
	    MageManaBarBgFrame:EnableMouse((MMBSettings[1])[3])
	    MageManaBarBgFrame:SetWidth((MMBSettings[1])[5])
	    MageManaBarBgFrame:SetHeight((MMBSettings[1])[6])
	    MageManaBarBgFrame:SetFrameLevel((MMBSettings[1])[9])
	    MageManaBarBgFrame:SetAlpha((MMBSettings[1])[10])
	    MageManaBarBgFrame:SetScale((MMBSettings[1])[4])
	    MageManaBarBgFrameTexture:SetVertexColor(unpack((MMBSettings[1])[7]))
	    if ((MMBSettings[1])[8] == true) then
	    	MageManaBarBgFrameTexture:Show()
	    else MageManaBarBgFrameTexture:Hide()
	    end
    else MageManaBarBgFrame:Hide()
    end
    
    -- settings for info frames ------------------------------------------------
    for i = 2,7 do
        _G[(MMBSettings[i])[1].."Text"]:SetFont((MMBSettings[15])[10],(MMBSettings[i])[4])
        _G[(MMBSettings[i])[1]]:EnableMouse((MMBSettings[i])[3]);
        _G[(MMBSettings[i])[1]]:SetWidth((MMBSettings[i])[5]);
        _G[(MMBSettings[i])[1]]:SetHeight((MMBSettings[i])[6]);
        _G[(MMBSettings[i])[1].."Texture"]:SetVertexColor(unpack((MMBSettings[i])[7]))
        if ((MMBSettings[i])[8] == true) then
    		_G[(MMBSettings[i])[1].."Texture"]:Show()
    	else _G[(MMBSettings[i])[1].."Texture"]:Hide()
        end
    	if ((MMBSettings[i])[2] == true) then
    		_G[(MMBSettings[i])[1]]:Show()
    	else _G[(MMBSettings[i])[1]]:Hide()
        end
    end
	
    if ((MMBSettings[13])[3] == true) then 
    	MageManaBarInfoFrameTexture:Show()
  	    MageManaBarInfoFrameTexture:SetVertexColor(unpack((MMBSettings[13])[7]))
    else MageManaBarInfoFrameTexture:Hide()
    end
    
    if ((MMBSettings[13])[2] == true) then
    	MageManaBarInfoFrame:Show()
	    MageManaBarInfoFrame:SetHeight((MMBSettings[13])[4])
		MageManaBarInfoFrame:SetWidth((MMBSettings[1])[5])
    else MageManaBarInfoFrame:Hide()
    end
    
	-- settings for mana markers icons --------------------------------------------
    for i = 8,12 do 
    	if ((MMBSettings[i])[2] == true) then
    		_G[(MMBSettings[i])[1]]:Show()
    	else _G[(MMBSettings[i])[1]]:Hide()
        end
    	if ((MMBSettings[i])[3] == true) then
    		_G[(MMBSettings[i])[1].."Icon"]:Show()
    		_G[(MMBSettings[i])[1].."Frame"]:Show()
    		if _G[(MMBSettings[i])[1].."Text"] then
    			_G[(MMBSettings[i])[1].."Text"]:Show()
    		end
    	else _G[(MMBSettings[i])[1].."Icon"]:Hide()
    		 _G[(MMBSettings[i])[1].."Frame"]:Hide()
    		 if _G[(MMBSettings[i])[1].."Text"] then
    		     _G[(MMBSettings[i])[1].."Text"]:Hide()
    		 end
    	end
    end

    if ((MMBSettings[1])[14] == true) then 
    	MMBmanaGemTextFrame:Show()
    	MMBevocationTextFrame:Show()
    	MMBArcaneTorrentTextFrame:Show()
    	MMBOrbTextFrame:Show()
    else MMBmanaGemTextFrame:Hide()
         MMBevocationTextFrame:Hide()
    	 MMBArcaneTorrentTextFrame:Hide()
    	 MMBOrbTorrentTextFrame:Hide()
    end

    for i = 1,#MMBprefixtable do -- adjust height of markers gradients
        
        _G["MMB"..MMBprefixtable[i]]:SetHeight((MMBSettings[1])[6]-2)
        _G["MMB"..MMBprefixtable[i].."gradred"]:SetHeight((MMBSettings[1])[6]-2)
        _G["MMB"..MMBprefixtable[i].."gradblack"]:SetHeight((MMBSettings[1])[6]-2)
        _G["MMB"..MMBprefixtable[i].."gradFrame"]:SetHeight((MMBSettings[1])[6]-2)
    end
    
    -- Settings for expected spell mana cost ---------------------------------------
    if ((MMBSettings[14])[2] == true) then
    	MMBspellcost:Show()
	    MMBspellcost:SetHeight((MMBSettings[1])[6]-2)
	    MMBspellcost:SetAlpha((MMBSettings[14])[3])
    else MMBspellcost:Hide()
   	end

    -- Settings for mana bar and overflow bar -------------------------------------
    MageManaBarOverflowFrame:SetStatusBarColor(unpack((MMBSettings[16])[7]))
    MageManaBarOverflowFrame:SetStatusBarTexture((MMBSettings[15])[8])
    MageManaBarOverflowFrame:SetWidth((MMBSettings[1])[5]-2)
    MageManaBarOverflowFrame:SetHeight((MMBSettings[1])[6]-2)
    
    MageManaBarFrame:SetStatusBarColor(unpack((MMBSettings[15])[7]))
    MageManaBarFrame:SetStatusBarTexture((MMBSettings[15])[8])
    MageManaBarFrame:SetWidth((MMBSettings[1])[5]-2)
    MageManaBarFrame:SetHeight((MMBSettings[1])[6]-2)
    
    -- Settings for warning Frame
    if ((MMBSettings[17])[2] == true) then
        MageManaBarWarning:Show()
        MageManaBarWarning:SetHeight((MMBSettings[17])[6])
        MageManaBarWarningBg2:SetHeight((MMBSettings[17])[6]-3)
        MageManaBarWarningBar:SetHeight((MMBSettings[17])[6]-3)
        MageManaBarWarning:SetWidth((MMBSettings[17])[5])
        MageManaBarWarningBg2:SetWidth((MMBSettings[17])[5]-4)
        MageManaBarWarningBar:SetWidth((MMBSettings[17])[5]-4)
        MageManaBarWarningText:SetWidth((MMBSettings[17])[5]-4)
        MageManaBarWarning:EnableMouse((MMBSettings[1])[3])
        MageManaBarWarningBar:SetStatusBarColor(unpack((MMBSettings[17])[7]))
        MageManaBarWarningBar:SetStatusBarTexture((MMBSettings[17])[8])
        if ((MMBSettings[17])[4] == true) then 
            MageManaBarWarningBg:Show()
            MageManaBarWarningBg2:Show()
        else MageManaBarWarningBg:Hide()
             MageManaBarWarningBg2:Hide()
        end
        MageManaBarWarningText:SetFont((MMBSettings[17])[10],(MMBSettings[17])[12])
    else MageManaBarWarning:Hide()
    end
    
    -- Added functions -------------------------------------------------------------
    MMBManabarMaxPool()
    MMBInfoSetPlace()
    MMBmageArmorSpec()
    MMBAutohide()
    MMBmagearmorupdate()
    MMBInfoFramesResize()

end

-------------------------------
-- Color picker function
function MMBColorPicker(instance)

	MMBcolorinstance = instance
 	ColorPickerFrame:SetColorRGB(((MMBSettings[instance])[7])[1],((MMBSettings[instance])[7])[2],((MMBSettings[instance])[7])[3]);
 	ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (((MMBSettings[instance])[7])[4] ~= nil), ((MMBSettings[instance])[7])[4];
 	ColorPickerFrame.previousValues = {((MMBSettings[instance])[7])[1],((MMBSettings[instance])[7])[2],((MMBSettings[instance])[7])[3],((MMBSettings[instance])[7])[4]};
 	ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = MMBCallback, MMBCallback, MMBCallback;
 	ColorPickerFrame:Hide(); -- Need to run the OnShow handler.
 	ColorPickerFrame:Show();

end

function MMBCallback (restore)

	local newR, newG, newB, newA;
	
	if restore then
		  newR, newG, newB, newA = unpack(restore);
	else newA, newR, newG, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB()
	end
	
	((MMBSettings[MMBcolorinstance])[7])[1],((MMBSettings[MMBcolorinstance])[7])[2],((MMBSettings[MMBcolorinstance])[7])[3],((MMBSettings[MMBcolorinstance])[7])[4] = newR, newG, newB, newA
    _G[(MMBSettings[MMBcolorinstance])[1].."SwatchTexture"]:SetVertexColor(unpack((MMBSettings[MMBcolorinstance])[7]))
    MMBFrameResize()
    
end


-------------------------------
-- Reset savedvariables function
function MMBreset()
    
    MMBSettings = {}
    for i = 1,#MMBBaseSettings do
        MMBSettings[i] = {}
        for z = 1,#MMBBaseSettings[i] do
            if type((MMBBaseSettings[i])[z]) == "table" then
                (MMBSettings[i])[z] = {}
                for x = 1,#(MMBBaseSettings[i])[z] do
                    ((MMBSettings[i])[z])[x] = ((MMBBaseSettings[i])[z])[x]
                end
            else (MMBSettings[i])[z] = (MMBBaseSettings[i])[z]
            end
        end
    end
    
    if (select(2, UnitRace("player")) == "BloodElf") then
        (MMBSettings[11])[2] = true
    else (MMBSettings[11])[2] = false
    end 
    
    MageManaBarBgFrame:ClearAllPoints() 
    MageManaBarBgFrame:SetPoint("CENTER",UIParent,"CENTER",0,0)
    
    print("MageManaBar settings have been reset.")

end

function MMBInfoFramesResize()

	local MMBinfowidth = ((MMBSettings[1])[5]-8)/7
	local MMBinfoheight = ((MMBSettings[13])[4]-6)/2

	for i = 1,6 do
		
		if not _G["MMBInfoFrame"..i]:IsUserPlaced() then 
			
			if (i < 5) then
				_G["MMBInfoFrame"..i]:SetWidth(MMBinfowidth*2)
			else _G["MMBInfoFrame"..i]:SetWidth(MMBinfowidth*3)
			end
			
			_G["MMBInfoFrame"..i]:SetHeight(MMBinfoheight)
			
			if (i == 1) or (i == 3) or (i == 5) then
				MMBcoordH = 2
			else MMBcoordH = 4 + MMBinfoheight
			end
			
			MMBcoordW = (ceil(i/2)*2) + ((ceil(i/2)-1) * (MMBinfowidth*2)) 
			
			_G["MMBInfoFrame"..i]:ClearAllPoints()
			_G["MMBInfoFrame"..i]:SetPoint("TOPLEFT", MageManaBarInfoFrame, "TOPLEFT", MMBcoordW, 0-MMBcoordH)
			
		end
	end
end

function MMBInfoFrameReset(...)

    for i = 1,select("#", ...) do
        for z = 1,#MMBBaseSettings[select(i, ...)] do
            if type((MMBBaseSettings[select(i, ...)])[z]) == "table" then
                for x = 1,#(MMBBaseSettings[select(i, ...)])[z] do
                    ((MMBSettings[select(i, ...)])[z])[x] = ((MMBBaseSettings[select(i, ...)])[z])[x]
                end
            else (MMBSettings[select(i, ...)])[z] = (MMBBaseSettings[select(i, ...)])[z]
            end
        end
        _G[(MMBSettings[select(i, ...)])[1]]:SetUserPlaced(nil)
    end

    MMBFrameResize()
    MMBInfoOptionsFrame:Hide()
    MMBInfoOptionsFrame:Show()
    
end

function MMBInfoCoords(frame,var)

    (MMBSettings[var])[9] = (frame:GetLeft() - MageManaBarInfoFrame:GetLeft());
    (MMBSettings[var])[10] = (frame:GetBottom() - MageManaBarInfoFrame:GetTop());
    _G[frame:GetName().."Xvalue"]:SetText(format("%.0f",(MMBSettings[var])[9]))
    _G[frame:GetName().."Yvalue"]:SetText(format("%.0f",(MMBSettings[var])[10]))
   
end

function MMBInfoSetPlace()
    
    for i = 1,6 do
        _G["MMBInfoFrame"..i]:ClearAllPoints()
        _G["MMBInfoFrame"..i]:SetPoint("BOTTOMLEFT",MageManaBarInfoFrame,"TOPLEFT",(MMBSettings[i+1])[9],(MMBSettings[i+1])[10])
        _G["MMBInfoFrame"..i.."Xvalue"]:SetText((MMBSettings[i+1])[9])
        _G["MMBInfoFrame"..i.."Yvalue"]:SetText((MMBSettings[i+1])[10])
    end
end

function MMBmanaInfoUpdate()

    local text
    
    if (GetPrimaryTalentTree() == 1) then 
        text = format("+%.1f%%", (1.5 * GetMastery()) * (UnitPower("player")/UnitPowerMax("player")))
	elseif (GetPrimaryTalentTree() == 2) then 
         text = format("+%.1f%%", 2.8 * GetMastery())
	elseif (GetPrimaryTalentTree() == 3) then 
        text = format("+%.1f%%", 2.5 * GetMastery())
    end
        
    if (MMBSettings[5])[11] == true then 
        text = (MMBSettings[5])[12]..text
    end
    
    MMBInfoFrame4Text:SetText(text)   
 
    if (MMBSettings[6])[11] == true then 
        MMBInfoFrame5Text:SetText(format("Max mana : %.1fk/%.1fk",MMBregmanapool/1000,UnitPowerMax("player")/1000))
    else MMBInfoFrame5Text:SetText(format("%.1fk/%.1fk",MMBregmanapool/1000,UnitPowerMax("player")/1000))
    end

    if (MMBSettings[7])[11] == true then 
        MMBInfoFrame6Text:SetText(format("Curr mana : %.1fk/%.1f%%",UnitPower("player")/1000, (UnitPower("player")/MMBregmanapool)*100))
    else MMBInfoFrame6Text:SetText(format("%.1fk/%.1f%%",UnitPower("player")/1000, (UnitPower("player")/MMBregmanapool)*100))
    end
end

function MMBAutohide()

    if ((MMBSettings[1])[12] == 1) then
        MageManaBarBgFrame:Show()
    elseif ((MMBSettings[1])[12] == 2) then
        if UnitAffectingCombat("player") then
            MageManaBarBgFrame:Show()
        else MageManaBarBgFrame:Hide()
        end
    elseif ((MMBSettings[1])[12] == 3) then
        if (GetPrimaryTalentTree() == 1) then
            MageManaBarBgFrame:Show()
        else MageManaBarBgFrame:Hide()
        end
    elseif ((MMBSettings[1])[12] == 4) then
        if UnitAffectingCombat("player") and (GetPrimaryTalentTree() == 1) then
            MageManaBarBgFrame:Show()
        else MageManaBarBgFrame:Hide()
        end
    end
    
end

function MMBSpellcastManaCost()

    if UnitCastingInfo("player") then
        MMBcurrentSpellcost = select(4,GetSpellInfo(select(1,UnitCastingInfo("player"))))
    else MMBcurrentSpellcost = nil
    end
    
    if (MMBcurrentSpellcost ~= nil) then
        MMBspellcost:Show()
        MMBspellcost:ClearAllPoints()
        MMBspellcost:SetPoint("TOPRIGHT",MageManaBarFrame,"TOPLEFT", (MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))+1,0)
        MMBspellcost:SetWidth((MageManaBarOverflowFrame:GetWidth()*(MMBcurrentSpellcost/UnitPowerMax("player")))+1)
    else MMBspellcost:Hide()
    end
end

function MMBManabarUpdate()

	MageManaBarFrame:SetValue(UnitPower("player"))
	if ((MMBSettings[1])[11] == true) then
        MageManaBarOverflowFrame:SetValue(UnitPower("player"))
    end

end

function MMBManabarMaxPool()

    MMBmanapoolmultiplier = 1.05
    MMBtempmanapool = 0

	for i = 1,40 do
	
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", i)
		
		if (spellId == 79061) or (spellId == 79063) then
			MMBmanapoolmultiplier = 1.1
		elseif spellId then
			for z = 1,#MMBbufflist do
				if (spellId == (MMBbufflist[z])[2]) then
					MMBtempmanapool = MMBtempmanapool + (MMBbufflist[z])[3]
                    table.insert(MMBcurrentbuff,{expirationTime,name,duration,(MMBbufflist[z])[3]})
					break
				end
			end	
		else break
		end
	end
	
	if (#MMBcurrentbuff ~= 0) then
	
	    for i = #MMBcurrentbuff,1,-1 do
	        
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", (MMBcurrentbuff[i])[2])
	        if (name == nil) then
	            table.remove(MMBcurrentbuff,i)
	        end
	    end
	end
    
    MMBtempmanapool = (MMBtempmanapool * MMBmanapoolmultiplier)
    MMBregmanapool = UnitPowerMax("player")-MMBtempmanapool
	MageManaBarFrame:SetMinMaxValues(0,MMBregmanapool)
	MageManaBarOverflowFrame:SetWidth(MageManaBarFrame:GetWidth() * (UnitPowerMax("player")/MMBregmanapool ))
	MageManaBarOverflowFrame:SetMinMaxValues(0,UnitPowerMax("player"))
    
    MMBmanaGem:ClearAllPoints()
    MMBmanaGem:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((MMBSettings[9])[4]/MMBregmanapool)),0)
    MMBevocation:ClearAllPoints()
    MMBevocation:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[8])[4])/100)),0)
    MMBArcaneTorrent:ClearAllPoints()
    MMBArcaneTorrent:SetPoint("BOTTOMLEFT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[11])[4])/100)),0)
    MMBOrb:ClearAllPoints()
    MMBOrb:SetPoint("BOTTOMLEFT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[12])[4])/100)),0)
    MMBOrb:ClearAllPoints()
    MMBOrb:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*((100-(MMBSettings[12])[4])/100)),0)

end

function MMBwarning()

	if select(2,GetSpellCooldown(12042)) > 1.6 then MMBarcaneCD = select(2,GetSpellCooldown(12042))-(GetTime()-select(1,GetSpellCooldown(12042)))
	else MMBarcaneCD = 0
	end
	
	if select(2,GetSpellCooldown(12051)) > 1.6 then MMBevocationCD = select(2,GetSpellCooldown(12051))-(GetTime()-select(1,GetSpellCooldown(12051)))
	else MMBevocationCD = 0
	end
	
	if select(2,GetSpellCooldown(5405)) > 1.6 then MMBmanaGemCD = select(2,GetSpellCooldown(5405))-(GetTime()-select(1,GetSpellCooldown(5405)))
	else MMBmanaGemCD = 0
	end
	
	if select(2,GetSpellCooldown(82731)) > 1.6 then MMBorbCD = select(2,GetSpellCooldown(82731))-(GetTime()-select(1,GetSpellCooldown(82731)))
	else MMBorbCD = 0
	end
	
	MMBmanapercent = (UnitPower("player")/MMBregmanapool)*100
	local text
    MMBoverflow = 0

--    local step = step
    
	if (UnitPower("player") > (UnitPowerMax("player")-MMBtempmanapool)) then -- warning when mana overflow
    
    	for i = #MMBcurrentbuff,1,-1 do
    	
    		MMBmanaoverflow = (UnitPower("player")-(UnitPowerMax("player")-MMBtempmanapool))/1000
    		MMBbuffoverflowtimer = (MMBcurrentbuff[i])[1]-GetTime()
    		
    		if (MMBmanaoverflow > 0) then
		        text = format("|cffff0000OVERFLOW : %.1fk / %.1fs|r", MMBmanaoverflow, MMBbuffoverflowtimer)
        		MageManaBarWarningBar:SetMinMaxValues(0,(MMBcurrentbuff[i])[3])
        		MageManaBarWarningBar:SetValue(MMBbuffoverflowtimer)
        		break
        	elseif ((MMBcurrentbuff[i])[4] <= MMBmanaoverflow) then
        		MMBmanaoverflow = MMBmanaoverflow - (MMBcurrentbuff[i])[4]
        	end
        end
        MMBoverflow = 1
        	
	elseif UnitAura("player", select(1,GetSpellInfo(12051))) then -- warning for evocation running
        text = format("|cffffffffEvocating...|r")
        MageManaBarWarningBar:SetValue(0)
	elseif (MMBarcaneCD > 75) and (MMBmanaGemCD == 0) and (GetItemCount(36799, false,true) ~= 0) then -- warning for mana gem use when AP running
		text = format("|cffffffffBurning, use gem now !!|r")
        MageManaBarWarningBar:SetValue(0)
	elseif (MMBorbCD == 0) and (MMBevocationCD > 15) and (MMBmanapercent < (MMBSettings[12])[4]) then -- warning for orb regen phase
		text = format("|cffffffff%.0f%% mana reached, use Orb now !!|r", (MMBSettings[12])[4])
        MageManaBarWarningBar:SetMinMaxValues(0,100)
        MageManaBarWarningBar:SetValue(MMBevocationCD-20)
	elseif (MMBorbCD == 0) and (MMBevocationCD > 15) then -- warning for orb burn phase
		text = format("|cffffffffOrb phase, mana at %.1f%%|r", MMBmanapercent)
        MageManaBarWarningBar:SetMinMaxValues(0,100)
        MageManaBarWarningBar:SetValue(MMBevocationCD-20)
	elseif (MMBorbCD > 45) and (MMBevocationCD > 15) then -- warning for orb AM Spam phase
		text = format("|cffffffffAM spam, next burn in %.1f|r", MMBevocationCD-15)
        MageManaBarWarningBar:SetMinMaxValues(0,100)
        MageManaBarWarningBar:SetValue(MMBevocationCD-20)
	elseif (MMBarcaneCD == 0) and (MMBevocationCD <= 20) then -- warning when burn phase is ready
		text = format("|cffffffffBurn phase ready...|r")
        MageManaBarWarningBar:SetValue(0)
  	elseif (MMBevocationCD == 0) and (MMBmanapercent < (MMBSettings[8])[4]) then -- warning when evocation mark reached
		text = format("|cffffffff%.0f%% mana reached, Evocate now !!|r",(MMBSettings[8])[4])
        MageManaBarWarningBar:SetValue(0)
  	elseif (MMBevocationCD > 20) and (MMBarcaneCD+20 < MMBevocationCD) then -- warning when waiting for next burn phase
		text = format("|cffffffffNext burn phase in %.1f|r", MMBevocationCD-15)
        MageManaBarWarningBar:SetMinMaxValues(0,100)
        MageManaBarWarningBar:SetValue(MMBevocationCD-20)
  	elseif (MMBarcaneCD > 0) then -- warning for burn phase
  		text = format("|cffffffffBurning, mana at %.1f%%|r", MMBmanapercent)
        MageManaBarWarningBar:SetValue(0)
    end
    
    MageManaBarWarningText:SetText(text)
    if MMBoverflow == 1 then
        MageManaBarWarningBar:SetStatusBarColor(1,0.5,0.8,0.5)
    else MageManaBarWarningBar:SetStatusBarColor(unpack((MMBSettings[17])[7]))
    end

end

function MMBSpellTimer(prefix,spellId)

    local start, duration, enable = GetSpellCooldown(spellId)
        
    if (duration > 1.55) and (_G["MMB"..prefix.."CDAnim"] == 0) then
        _G["MMB"..prefix.."Cooldown"]:SetCooldown(start,duration)
        _G["MMB"..prefix.."CDAnim"] = 1
    elseif (duration == 0) and (_G["MMB"..prefix.."CDAnim"] == 1) then
        _G["MMB"..prefix.."gradCooldown"]:SetCooldown(0,0)
        _G["MMB"..prefix.."CDAnim"] = 0
    end
    
    if (duration > 1.55) then
        
        MMBspellCD = tonumber(format("%.0f",duration-(GetTime()-start)))
        
        local filename, fontHeight, flags = _G["MMB"..prefix.."Timer"]:GetFont()
        
        if (MMBspellCD < 10) then
        
            if (_G["MMB"..prefix.."Flash"] < 3) then
                _G["MMB"..prefix.."Timer"]:SetText(format("|cffff0000%.0f|r",MMBspellCD))
                _G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
            elseif (_G["MMB"..prefix.."Flash"] < 6) then
                _G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
                _G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
            else  _G["MMB"..prefix.."Flash"] = 1
            end
            
            if (_G["MMB"..prefix.."resize"] == 2) then 
            _G["MMB"..prefix.."Timer"]:SetFont(filename,13.3,flags) -- fontHeight*(_G["MMB"..prefix.."Icon"]:GetHeight()/_G["MMB"..prefix.."Timer"]:GetStringHeight())*0.90
            _G["MMB"..prefix.."resize"] = 0
            end

        elseif (MMBspellCD < 60) then
        
            _G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
            
            if (_G["MMB"..prefix.."resize"] == 1) then 
                _G["MMB"..prefix.."Timer"]:SetFont(filename,9.8,flags) -- fontHeight*(_G["MMB"..prefix.."Icon"]:GetHeight()/_G["MMB"..prefix.."Timer"]:GetStringHeight())*0.70
                _G["MMB"..prefix.."resize"] = 2
            end
            
        elseif (MMBspellCD >= 60) then
        
            _G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%d:%0.2d|r",MMBspellCD / 60, MMBspellCD % 60))
            
            if (_G["MMB"..prefix.."resize"] == 0) then 
                _G["MMB"..prefix.."Timer"]:SetFont(filename,7.5,flags) --fontHeight*(_G["MMB"..prefix.."Icon"]:GetHeight()/_G["MMB"..prefix.."Timer"]:GetStringHeight())*0.50
                _G["MMB"..prefix.."resize"] = 1
            end
        end
        
        _G["MMB"..prefix.."gradred"]:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,1,0.8,0.2,0.2,0)
        
    else _G["MMB"..prefix.."Timer"]:SetText("")
    
        if ((MMBSettings[1])[15] == true) then
            _G["MMB"..prefix.."gradred"]:SetGradientAlpha("VERTICAL",0.2,0.8,0.2,1,0.2,0.8,0.2,0)
        else _G["MMB"..prefix.."gradred"]:SetGradientAlpha("VERTICAL",0.8,0.2,0.2,1,0.8,0.2,0.2,0)
        end
        
    end
    
    if (spellId == 5405) and (GetItemCount(36799, false,true) == 0) then
        MMBmanaGemIcon:SetVertexColor(1,0,0,1)
    elseif (spellId == 5405) and (GetItemCount(36799, false,true) ~= 0) then
        MMBmanaGemIcon:SetVertexColor(1,1,1,1)
    end
    
end

function MMBmageArmorSpec()

    if (GetPrimaryTalentTree() ~= 1) and ((MMBSettings[10])[5] == false) then
        MMBmageArmor:Hide()
    else MMBmageArmor:Show()
    end
    
end        

function MMBmagearmorupdate()

    MMBmageArmor:ClearAllPoints()
    if (MMBmageArmorIcon:GetTexture() == "Interface\\Icons\\Spell_Frost_FrostArmor02") then
        MMBmageArmor:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", ceil((MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))+(MageManaBarOverflowFrame:GetWidth()*((102/100)-1))),0)
    else MMBmageArmor:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", ceil((MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player")))+(MageManaBarOverflowFrame:GetWidth()*(((MMBSettings[10])[4]/100)-1))),0)
    end

end
            
function MMBCreateTextureList(frame,row,col)

    MMBTextureList = {} for k in pairs(MMBLSM:HashTable("statusbar")) do tinsert(MMBTextureList,{k,MMBLSM:HashTable("statusbar")[k]}) end
    
    MMBTextureFrame:Show()
    MMBTextureFrame:ClearAllPoints()
    MMBTextureFrame:SetWidth(170)
    MMBTextureFrame:SetHeight(#MMBTextureList*20+20)
    MMBTextureFrame:SetPoint("CENTER",frame,"CENTER",0,0-(MMBTextureFrame:GetHeight()/4))
    MMBTextureFrame:SetParent(frame)
    MMBTextureFrame:SetFrameLevel(_G[frame:GetName().."Button"]:GetFrameLevel()+1)
    MMBTextureFrame:SetScale(1.3)
    MMBTextureRow = row
    MMBTextureCol = col
    MMBTextureDDown = frame
    
    for i = 1,#MMBTextureList do
    
        CreateFrame("button", "MMBTexture"..i, MMBTextureFrame, "MMBTextureTemplate")
        
        if i == 1 then
            MMBTexture1:ClearAllPoints()
            MMBTexture1:SetPoint("TOP",MMBTextureFrame,"TOP",0,-10)
        else _G["MMBTexture"..i]:ClearAllPoints()
             _G["MMBTexture"..i]:SetPoint("TOP",_G["MMBTexture"..i-1],"BOTTOM",0,0)
        end
        
        _G["MMBTexture"..i.."Bar"]:SetTexture((MMBTextureList[i])[2])
        _G["MMBTexture"..i.."Bar"]:SetVertexColor(unpack((MMBSettings[row])[7]))
        _G["MMBTexture"..i.."Text"]:SetText((MMBTextureList[i])[1])
        
        if (MMBTextureList[i])[1] == (MMBSettings[row])[col+1] then
            _G["MMBTexture"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
        else _G["MMBTexture"..i.."Text"]:SetTextColor(1,1,1,1)
        end
    
    end
    
end
            
function MMBCreateFontList(frame,row,col)

    MMBFontList = {} for k in pairs(MMBLSM:HashTable("font")) do tinsert(MMBFontList,{k,MMBLSM:HashTable("font")[k]}) end
    
    MMBFontFrame:Show()
    MMBFontFrame:ClearAllPoints()
    MMBFontFrame:SetWidth(170)
    MMBFontFrame:SetHeight(#MMBFontList*15+20)
    MMBFontFrame:SetPoint("CENTER",frame,"CENTER",0,0-(MMBFontFrame:GetHeight()/4))
    MMBFontFrame:SetParent(frame)
    MMBFontFrame:SetFrameLevel(_G[frame:GetName().."Button"]:GetFrameLevel()+1)
    MMBFontFrame:SetScale(1.3)
    MMBFontRow = row
    MMBFontCol = col
    MMBFontDDown = frame
    
    for i = 1,#MMBFontList do
    
        CreateFrame("button", "MMBFont"..i, MMBFontFrame, "MMBFontTemplate")
        
        if i == 1 then
            MMBFont1:ClearAllPoints()
            MMBFont1:SetPoint("TOP",MMBFontFrame,"TOP",0,-10)
        else _G["MMBFont"..i]:ClearAllPoints()
             _G["MMBFont"..i]:SetPoint("TOP",_G["MMBFont"..i-1],"BOTTOM",0,0)
        end
        
        _G["MMBFont"..i.."Bar"]:SetTexture((MMBSettings[row])[col-2])
        _G["MMBFont"..i.."Bar"]:SetVertexColor(unpack((MMBSettings[row])[7]))
        _G["MMBFont"..i.."Text"]:SetText((MMBFontList[i])[1])
        _G["MMBFont"..i.."Text"]:SetFont((MMBFontList[i])[2],9)
        
        if (MMBFontList[i])[1] == (MMBSettings[row])[col+1] then
            _G["MMBFont"..i.."Text"]:SetTextColor(1,0.8,0.2,1)
        else _G["MMBFont"..i.."Text"]:SetTextColor(1,1,1,1)
        end
    
    end
    
end
      
function MMBTimeToDie(unit) 
	if unit ~= UnitName("target") then return end

	local health = UnitHealth("target")
    local text
    
	if health == UnitHealthMax("target") or UnitName("target") == nil then
		health0, time0, mhealth, mtime = nil
        text = "--"
		return
	end

	local time = GetTime()

	if not health0 then
		health0, time0 = health, time
		mhealth, mtime = health, time
		return
	end

	mhealth = (mhealth + health) * .5
	mtime = (mtime + time) * .5

	if mhealth >= health0 then
		health0, time0, mhealth, mtime = nil
        text = "Healing"
	else  
		MMBTimeToDIE = health * (time0 - mtime) / (mhealth - health0)
        if (MMBTimeToDIE <= 60) then
            text = format("%0.2d",MMBTimeToDIE)
        elseif (MMBTimeToDIE > 60) then
            text = format("%d:%0.2d",MMBTimeToDIE / 60, MMBTimeToDIE % 60)
        end
	end
    
    if (MMBSettings[3])[11] == true then 
        text = (MMBSettings[3])[12]..text
    end
    
    MMBInfoFrame2Text:SetText(text)   
    
end

function MMBTimeToOom() 

	local mana = UnitPower("player")
    local text
    
	if mana == UnitPowerMax("player") then
		mana0, manatime0, mmana, manamtime = nil
        text = "--"
		return
	end

	local manatime = GetTime()

	if not mana0 then
		mana0, manatime0 = mana, manatime
		mmana, manamtime = mana, manatime
		return
	end

	mmana = (mmana + mana) * .5
	manamtime = (manamtime + manatime) * .5

	if mmana >= mana0 then
		mana0, manatime0, mmana, manamtime = nil
        text = "Regen"
	else  
		MMBTimeToOOM = mana * (manatime0 - manamtime) / (mmana - mana0)
        if (MMBTimeToOOM <= 60) then
            text = format("%0.2d",MMBTimeToOOM)
        elseif (MMBTimeToOOM > 60) then
            text = format("%d:%0.2d",MMBTimeToOOM / 60, MMBTimeToOOM % 60)
        end
	end
    
    if (MMBSettings[2])[11] == true then 
        text = (MMBSettings[2])[12]..text
    end
    
    MMBInfoFrame1Text:SetText(text)   

end

	
	
MMBcurrentbuff = {}
    
MMBbufflist = {
	
	{"Power Torrent", 74241, 7500},
	{"Volcanic Power", 79476, 18000},
	{"Volcanic Destruction", 89091, 24000},
	{"Lightweave", 75170, 8700},
	{"Lightweave", 55367, 4425},
	{"Synapse Springs", 96230, 7200}
}
-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_EVENT FUNCTION ----------------------------------------------------

function MageManaBar_OnEvent(self, event, ...)

    if (event == "PLAYER_LOGIN") then
    
   		MageManaBarWarningBar:SetMinMaxValues(0,2)
        
 		CreateFrame("Cooldown","MMBevocationCooldown",MMBevocationFrame)
		MMBevocationCooldown:SetAllPoints(MMBevocationFrame)
        MMBevocationCooldown.noCooldownCount = true
 		CreateFrame("Cooldown","MMBevocationgradCooldown",MMBevocationgradFrame)
		MMBevocationgradCooldown:SetAllPoints(MMBevocationgradFrame)
        CreateFrame("Cooldown","MMBmanaGemCooldown",MMBmanaGemFrame)
		MMBmanaGemCooldown:SetAllPoints(MMBmanaGemFrame)
        MMBmanaGemCooldown.noCooldownCount = true
        CreateFrame("Cooldown","MMBmanaGemgradCooldown",MMBmanaGemgradFrame)
		MMBmanaGemgradCooldown:SetAllPoints(MMBmanaGemgradFrame)
        CreateFrame("Cooldown","MMBmageArmorgradCooldown",MMBmageArmorgradFrame)
		MMBmageArmorgradCooldown:SetAllPoints(MMBmageArmorgradFrame)
        CreateFrame("Cooldown","MMBmageArmorCooldown",MMBmageArmorFrame)
		MMBmageArmorCooldown:SetAllPoints(MMBmageArmorFrame)
        MMBmageArmorCooldown.noCooldownCount = true
	    CreateFrame("Cooldown","MMBArcaneTorrentCooldown",MMBArcaneTorrentFrame)
		MMBArcaneTorrentCooldown:SetAllPoints(MMBArcaneTorrentFrame)
        MMBArcaneTorrentCooldown.noCooldownCount = true
	    CreateFrame("Cooldown","MMBArcaneTorrentgradCooldown",MMBArcaneTorrentgradFrame)
		MMBArcaneTorrentgradCooldown:SetAllPoints(MMBArcaneTorrentgradFrame)
        CreateFrame("Cooldown","MMBOrbCooldown",MMBOrbFrame)
		MMBOrbCooldown:SetAllPoints(MMBOrbFrame)
        MMBOrbCooldown.noCooldownCount = true
	    CreateFrame("Cooldown","MMBOrbgradCooldown",MMBOrbgradFrame)
		MMBOrbgradCooldown:SetAllPoints(MMBOrbgradFrame)
        
        if (select(2, UnitRace("player")) == "BloodElf") then
            (MMBSettings[11])[2] = true
        else (MMBSettings[11])[2] = false
        end 
        
        MMBFrameResize()
        
    elseif (event == "UNIT_POWER") or (event == "PLAYER_ENTERING_WORLD") then
            	
    	local unit, powertype = select(1, ...)
    	
    	if (unit == "player") or (event == "PLAYER_ENTERING_WORLD") then
    	
            MMBmagearmorupdate()
            MMBManabarUpdate()
            
    	end

    elseif (event == "UNIT_MAXPOWER") then
    	
    	local unit, powertype = select(1, ...)
    	
    	if (unit == "player") then
    	
    		MMBManabarMaxPool()
            MMBmagearmorupdate()
    		
    	end
        
    elseif (event=="COMBAT_LOG_EVENT_UNFILTERED") then

    	if (select(4,GetBuildInfo()) >= 40200)
    		then timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = select(1, ...)
    	else timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = select(1, ...)
    	end
            
            if (sourceName == UnitName("player")) then
            	
            	if (event == "SPELL_PERIODIC_ENERGIZE") and (spellId == 6117) then -- mage armor cooldown
            		MMBmageArmorgradCooldown:SetCooldown(0,0)
            		MMBmageArmorCooldown:SetCooldown(GetTime(),5)
       			end
            end
            
    elseif (event == "PLAYER_REGEN_DISABLED") or (event == "PLAYER_REGEN_ENABLED") or (event == "PLAYER_TALENT_UPDATE") then
    
        MMBAutohide()
        MMBmageArmorSpec()
        
	end
    
end

-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_UPDATE FUNCTION ----------------------------------------------------

function MageManaBar_OnUpdate(self, elapsed)
    self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
    self.TimeSinceLastUpdate1sec = (self.TimeSinceLastUpdate1sec or 0) + elapsed;
    
		if (self.TimeSinceLastUpdate > MageManaBar_UpdateInterval) then
            
            MMBmanaInfoUpdate()
            MMBwarning()
            
            if ((MMBSettings[14])[2] == true) then
                MMBSpellcastManaCost()
            end
            
            if (MMBInfoCoordsTarget ~= nil) then
                MMBInfoCoords(_G[MMBInfoCoordsTarget[1]],MMBInfoCoordsTarget[2])
            end
            
            if ((MMBSettings[1])[14] == true) then 
                MMBSpellTimer("manaGem",5405)
                MMBSpellTimer("evocation",12051)
                MMBSpellTimer("ArcaneTorrent",28730)
                MMBSpellTimer("Orb",82731)
            end
            
            ------------------------------------- TTOOM and TTdie stuff
            
            local health = UnitHealth("target")
            if oldhealth ~= health then
                oldhealth = health
                MMBTimeToDie(UnitName("target"))
            end

            local mana = UnitPower("player")
            if oldmana ~= mana then
                oldmana = mana
                MMBTimeToOom()
            end

            self.TimeSinceLastUpdate = 0
            
        end

		if (self.TimeSinceLastUpdate1sec > MageManaBar1sec_UpdateInterval) then
               			
            ------------------------------------- Mage Armor stuff
            if select(1,UnitAura("player",select(1,GetSpellInfo(7302)))) and (MMBmageArmorIcon:SetTexture() ~= "Interface\\Icons\\Spell_Frost_FrostArmor02") then
                if (select(4,GetGlyphSocketInfo(1)) == 98397) or (select(4,GetGlyphSocketInfo(4)) == 98397) or (select(4,GetGlyphSocketInfo(6)) == 98397) then 
                MMBmageArmorIcon:SetVertexColor(1,1,1,1)
                MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_Frost_FrostArmor02")
                MMBmagearmorupdate()
                end
            elseif select(1,UnitAura("player",select(1,GetSpellInfo(6117)))) then
                MMBmageArmorIcon:SetVertexColor(1,1,1,1)
                MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_MageArmor")
            else MMBmageArmorIcon:SetVertexColor(1,0,0,1)
                 MMBmageArmorIcon:SetTexture("Interface\\Icons\\Spell_MageArmor")
            end

            self.TimeSinceLastUpdate1sec = 0
            
        end
end


SLASH_MMBCONFIG1 = "/magemanabar"

SlashCmdList["MMBCONFIG"] = function(msg)

	if msg == "" or  msg == "help" or  msg == "?" or msg == "config" then
		 InterfaceOptionsFrame_OpenToCategory("MageManaBar")
	else
		 InterfaceOptionsFrame_OpenToCategory("MageManaBar")
	end

end